﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _805669
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        private List<Supplier> suplierList;
        BindingSource productsBinding;

        public RadForm1()
        {
            InitializeComponent();
            radDataEntry1.BindingCreating += radDataEntry1_BindingCreating;
            radDataEntry1.BindingCreated += radDataEntry1_BindingCreated;
            radDataEntry1.EditorInitializing += radDataEntry1_EditorInitializing;

            suplierList = new List<Supplier>();
            suplierList.Add(new Supplier(1, "(1) Exotic Liquids"));
            suplierList.Add(new Supplier(2, "(2) New Orleans Cajun Delights"));
            suplierList.Add(new Supplier(3, "(3) Tokyo Traders"));
            suplierList.Add(new Supplier(4, "(4) Norske Meierier"));
            suplierList.Add(new Supplier(5, "(5) New England Seafood Cannery"));
            suplierList.Add(new Supplier(6, "(6) Leka Trading"));
            // I create the record here to be displayed in the RadDataEntry form
        }

        void radDataEntry1_EditorInitializing(object sender, Telerik.WinControls.UI.EditorInitializingEventArgs e)
        {
            if (e.Property.Name == "SupplierItem")
            {
                var radDropDownList1 = new RadDropDownList();
                radDropDownList1.DataSource = suplierList;
                radDropDownList1.ValueMember = "SupplierID";
                radDropDownList1.DisplayMember = "CompanyName";
                radDropDownList1.Parent = this;
                e.Editor = radDropDownList1;
            }
        }

        void radDataEntry1_BindingCreating(object sender, Telerik.WinControls.UI.BindingCreatingEventArgs e)
        {
            if (e.DataMember == "SupplierItem")
            {
                e.PropertyName = "SelectedValue";
            }
        }

        void radDataEntry1_BindingCreated(object sender, BindingCreatedEventArgs e)
        {
            if (e.DataMember == "SupplierItem")
            {
                e.Binding.FormattingEnabled = true;
                e.Binding.Parse += new ConvertEventHandler(Binding_Parse);
            }
        }

        private void Binding_Parse(object sender, ConvertEventArgs e)
        {
            int tmpvalue;
            int? result = int.TryParse(e.Value.ToString(), out tmpvalue) ? tmpvalue : (int?)null;
            e.Value = result;
        }

        private void RadForm1_Load(object sender, EventArgs e)
        {
        }

        Random rnd = new Random();

        private void button1_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 20; i++)
            {
                var record = new Record();
                record.SupplierItem = rnd.Next(5); 
                radDataEntry1.DataSource = record;
            }
        }
    }

    public class Record
    {
        public int SupplierItem { get; set; }
    }

    public partial class Supplier
    {
        private int? _supplierID;
        private string _companyName;

        public Supplier(int? supplierID, string companyName)
        {
            this._supplierID = supplierID;
            this._companyName = companyName;
        }

        public int? SupplierID
        {
            get
            {
                return this._supplierID;
            }
            set
            {
                this._supplierID = value;
            }
        }

        public string CompanyName
        {
            get
            {
                return this._companyName;
            }
            set
            {
                this._companyName = value;
            }
        }
    }
}